/*	vprintf.c

	 ࠭祭 ଠ⭮ 뢮  蠡 %c %s %%.

	(C) ..஢,   PAH 1992 - 1999
	All Rights Reserved.
*/
#include <io.h>
#include <stdarg.h>
#include <string.h>

#define	_exput(s,len)	write (1, (char*) (s), len)
#define PDIF(f,s)	((unsigned) (f) - (unsigned) (s))

int	vprintf (const char* format, va_list argptr)	// ଠ 뢮.
{
  register const char* f;
  register const char* s;
  char c;

  for (f = s = format; *f; f++)
  if (*f == '%')
  {
    _exput (s, PDIF (f, s));
    switch (*++f) {
      case 'c': c = (char) va_arg (argptr, int); _exput (&c, 1);
		s = f + 1; break;
      case 's': s = va_arg (argptr, char*); if (s) _exput (s, strlen (s));
		s = f + 1; break;
      case '0': f--;
      default:  s = f;
    }
  }
  return (_exput (s, PDIF (f, s)));	//  ᫮ ᠭ ᨬ.
}
