/*      exdef.h

         ।  㭪樨.

        (C) ..஢,   PAH, 1992 - 2002
        All Rights Reserved.
*/
#ifndef _EXDEF_H
#define _EXDEF_H
#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

//      ਧ 32-ࠧ來 ०.
#ifndef __FLAT__
#ifndef __TURBOC__
#define __FLAT__
#endif
#endif

//      ஫ 㪠⥫
//      CONST            ஫஢ 㪠⥫ ⨯ CONST

//      ᯮ짮 ॣ஢
//      __NOREG__        ᯮ짮 ॣ 饣 祭
//      __NOSEGREG__     ᯮ짮 ᥣ ॣ

//      몮 ᮡ
//      __NOLCAST__      ᪠ ਢ ⨯ ᫥  ᢠ

//      ஫ 㪠⥫.
#ifndef CONST
#define CONST   const
#endif//CONST

//      ⠭  32  16-ࠧ來 ०.
#ifdef __FLAT__
#define near
#define far
#define huge
#define __NOSEGREG__
#define __NOLCAST__
#elif defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
#define __SEGMENT__
#endif//__FLAT__

//        ANSI .
#ifdef  __STDC__
#define __NOREG__
#define __NOSEGREG__
#define __NOLCAST__
#endif//__STDC__

//        Visual .
#ifndef __TURBOC__
#define __NOREG__
#define __NOSEGREG__
#define __NOLCAST__
#endif//__TURBOC__

//      襭  .
//      STDECL - ⠭⭮ ᮣ襭
//      EXDECL - 㭪  䨪o ஬ ࠬ஢
//      FCDECL - 㭪  ।祩 ࠬ஢ १ ॣ
//      INDECL - force-inline 㭪 (⮫쪮  ० ++)
//      VDECL  -  ६
#ifdef  __STDC__
#define STDECL
#else /*__STDC__*/
#define STDECL  __cdecl
#ifdef  _MSC_VER
#if     _MSC_VER >= 1200
#define INDECL  __forceinline
#endif/*_MSC_VER*/
#endif/*_MSC_VER*/
#endif/*__STDC__*/

#ifndef EXDECL
#define EXDECL  STDECL
#endif/*EXDECL*/

#ifndef FCDECL
#define FCDECL  STDECL
#endif/*FCDECL*/

#ifndef INDECL
#define INDECL  inline
#endif/*INDECL*/

#define VDECL

//       ᥣ 㪠⥫.
#if defined(__SEGMENT__) && !defined(__NOSEGREG__)
#define SCONS(p,sp)     ( (void _seg *) (void far *) (p) + (sp) )
#define SLOAD(s,p)      ( (s) = (unsigned) (void _seg *) (void far *) (p) )
#define SREG(s)         s
#else
#define SCONS(p,sp)     (sp)
#define SLOAD(s,p)      ((void)0)
#define SREG(s)
#endif
#define DSLOAD(p)       SLOAD(_DS,p)
#define ESLOAD(p)       SLOAD(_ES,p)
#define FSLOAD(p)       SLOAD(_FS,p)
#define GSLOAD(p)       SLOAD(_GS,p)
#define DS_             SREG(_ds)
#define ES_             SREG(_es)
#define FS_             SREG(_fs)
#define GS_             SREG(_gs)
typedef size_t  POFF;
#define POFF(p)         ((size_t)(const void *)(p))
#define PDIF(p1,p2)     (POFF(p1) - POFF(p2))
//       ॣ.
#ifndef __NOREG__
#define AL      _AL
#define AH      _AH
#define AX      _AX
#define BX      _BX
#define CX      _CX
#define DX      _DX
#ifndef __FLAT__
#define EAX     _AX
#define EBX     _BX
#define ECX     _CX
#define EDX     _DX
#define ESP     _SP
#define EBP     _BP
#define ESI     _SI
#define EDI     _DI
#else //__FLAT__
#define EAX     _EAX
#define EBX     _EBX
#define ECX     _ECX
#define EDX     _EDX
#define ESP     _ESP
#define EBP     _EBP
#define ESI     _ESI
#define EDI     _EDI
#endif//__FLAT__
#else //__NOREG__
typedef union   {
        unsigned int    D;
        unsigned short  W;
        unsigned char   B [2];
}       __EXREG;
extern  __EXREG VDECL   __EXREGS [4];
#define AL      __EXREGS [0].B [0]
#define AH      __EXREGS [0].B [1]
#define AX      __EXREGS [0].W
#define BX      __EXREGS [1].W
#define CX      __EXREGS [2].W
#define DX      __EXREGS [3].W
#define EAX     __EXREGS [0].D
#define EBX     __EXREGS [1].D
#define ECX     __EXREGS [2].D
#define EDX     __EXREGS [3].D
#endif //__NOREG__

//        
typedef signed   char   SCHAR;
typedef unsigned char   UCHAR;
typedef unsigned short  USHORT;
typedef unsigned int    UINT;
typedef unsigned long   ULONG;
typedef int   (STDECL * FCMP)   (const void *, const void *);

//      ம।.
#ifndef MAX
#define MAX(a,b)    (((a) > (b)) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b)    (((a) < (b)) ? (a) : (b))
#endif
#ifndef LOBYTE                                          /* 쭮 ! */
#define LOBYTE(n)       ( (unsigned char) (n) )
#define HIBYTE(n)       ( (unsigned char) ((unsigned int) (n) >> 8) )
#endif
#ifndef LOWORD                                          /* 쭮 ! */
#define LOWORD(n)       ( (unsigned int) (n) )
#define HIWORD(n)       ( (unsigned int) ((unsigned long) (n) >> 16) )
#endif

#define EXP2(n)         ( ((unsigned int)  1) << ((n) - 1) )
#define EXP2L(n)        ( ((unsigned long) 1) << ((n) - 1) )
#define LENGTH(array)   ( sizeof (array) / sizeof (*(array)) )
#define ASSIGNCHAR(s,c) (* (unsigned short *) (s) = (c))/* 쭮 ! */
#define FIRSTCHARS(s)   (* (unsigned short *) (s))      /* 쭮 ! */

// =========================================================================
//      ப 㭪樨.
// =========================================================================
char*   STDECL  str0cpy (char *dst, const char *src, size_t maxdst);
                                                // ஢  0.
char*   STDECL  str0cat (char *dst, const char *src, size_t maxdst);
                                                // ⥭  0.
const   char*   STDECL  itoatmp  (int   num);   // ८ࠧ  ப.
const   char*   STDECL  ltoatmp  (long  num);
const   char*   STDECL  uitoatmp (unsigned int  num);
const   char*   STDECL  ultoatmp (unsigned long num);

// =========================================================================
//        .
// =========================================================================
int     STDECL  getch8  (void);         // ⥭  .
int     STDECL  getkey  (void);         // ⥭ .
void    STDECL  clrkey  (void);         // ⪠  .

// =========================================================================
//      뢮  ନ.
// =========================================================================
void    STDECL  exprintf (const char* format, ...);     // ଠ 뢮.
void    STDECL  exputc   (int c);                       // 뢮 ᨬ.
void    STDECL  exputs   (const char* psz);             // 뢮 ⥪.
void    STDECL  exputtmp (const char* psz);
                                        // 뢮 ६ ப, ࠥ
                                        //  ᫥饬 뢮  ࠭.
void    STDECL  exprogress (            // 뢮 ண-.
        const   char*   pszItem,        //  .
                size_t  nItem,          //   .
         unsigned long  kProg,          // 祭 .
         unsigned long  mProg,          // ᨬ .
                size_t  nProg,          // 騩 ࠧ  0..MAXPROG.
                size_t  nList           //  ,  饣 ⪥
);                                      //  ᫥饬 뢮. ᫨ >0,
                                        //  ᫥ ⪨ 뢮 '\n'.
// =========================================================================
//      뢮 ண-.
// =========================================================================
void    STDECL  exprogress_open (       //  ண-.
        const   char*   pszItem,        //  .
                size_t  nItem           //    .
);
void    STDECL  exprogress_show (       // 뢮 ண-.
         unsigned long  kProg,          // 祭 .
         unsigned long  mProg           // ᨬ .
);
void    STDECL  exprogress_close(void); //  ண-.

// =========================================================================
//      뢮 ᮮ饭  ࠡ⪠ ᪫⥫ 権.
// =========================================================================
void    STDECL  exprintinfo  (const char* format,...);// ଠ.
void    STDECL  exprintwarn  (const char* format,...);// ।०.
void    STDECL  exprinterror (const char* format,...);// ४㥬 訡.
void    STDECL  exprintfail  (const char* format,...);// ᪠ 訡.
void    STDECL  exerror_handle  (void);               // ४㥬 訡.
void    STDECL  exfail_handle   (void);               // ᪠ 訡.

// =========================================================================
//      ࠢ ࠡ⪮ 訡.
// =========================================================================
extern  int         VDECL excatch;      // ਧ 墠 訡.
extern  int         VDECL excatch_error;// 墠 ४㥬 訡.
//      㭪樨 exprinterror  exerror_handle  excatch_error <= 0
//      뢠 ࠡ稪 ᪨ 訡 exfail_handle,
//       ⠭ excatch = 2.
//        ᢠ excatch 㫥 祭  ࠡ 㭪権
//        exbase, 믮 䠩 -뢮  䠩 樨.
//        ஢ 㭪樨  ⢨    ,
//        祣, ஬ ᢮ ࠭  ᮢ.
//      㭪樨 exprintfail  exfail_handle 뢠 (*_exthrow_handler)().
//        _exthrow_handler, ᫨   ᢮  祭, 맢
//        㭪 _exthrow,  ࠡ ணࠬ   2.

// =========================================================================
//      ࠢ ࠡ⪮ ᪫祭.
// =========================================================================
void    STDECL  exthrow        (void);  //  ᪫祭 2.
void    STDECL  _exthrow       (void);  // 室   2.
extern  void    (* VDECL _exthrow_handler) (void) /* = _exthrow */;
                                        // ⥫ 㭪樨 ᪠ ᪫祭.

// =========================================================================
//      ࠢ 뢮  ࠭  ଠ ᮮ饭.
// =========================================================================
void    STDECL  exinit        (void);   // 墠 ࠭  FW  ANSI.SYS,
void    STDECL  _exinit       (void);   // ⠭ ਧ 뢮  ࠭.
extern  void    (* VDECL _exinit_handler) (void) /* = _exinit */;
                                        // ⥫ 㭪樨 墠 ࠭.
//      (*_exinit_handler) ⨢ _exinit, ⠭ ਧ 뢮
//       ࠭, ᫨ ⮫쪮   ࠧ  ᢮  㪭.

extern  int     VDECL   exprint;        //  뢮  exprintinfo
//      < 0 - 뢮  ந
//        0 - 뢮 ந (㬮砭).
//      > 0 - + 뢮 ஢ ᮮ饭 ஢ 1..exprint.

//      ⠭ ଠ:
#define szF1    (szF2    + 3)
#define szF1to1 (szF2to1 + 3)
#define szF11   (szF21   + 3)
extern  const   char    VDECL   szF2    [];     // %s %s\n
extern  const   char    VDECL   szF2to1 [];     // %s %s -> %s\n
extern  const   char    VDECL   szF21   [];     // %s %s: %s\n

#ifdef __cplusplus
}
#endif

// =========================================================================
//      -।.
// =========================================================================
#define itoatmp(num)    ltoatmp(num)
#define uitoatmp(num)   ultoatmp(num)
#define exputc(c)       (exprintinfo ("%c", c))
#define exputs(s)       (exprintinfo ("%s", s))
#define exfail_handle() ((*_exthrow_handler)())
#define MAXITEM 13
#define MAXPROG 77

// =========================================================================
//      ࠡ⪠ 㬥⮢  ப.
// =========================================================================
#define GETMODE(argc,argv)              \
for (;argc > 1; argc--, argv++)         \
{                                       \
  switch (FIRSTCHARS (argv [1])) {      \
    case '+': exprint++; continue;      \
  } break;                              \
}
#endif
