/*	exhandle.h

	᪨ 㭪樨.

	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#ifndef _EXHANDLE_H
#define _EXHANDLE_H

#include <errno.h>				// 祭 errno.

#ifndef _EXDEF_H
#include <exdef.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern	const	char	VDECL	szRDONLY   [];	// ⠥.
extern	const	char	VDECL	szWRONLY   [];	// 襬.
extern	const	char	VDECL	szRDWR     [];	// 塞.
extern	const	char	VDECL	szOPENFAIL [];	// 訡  ⨨.
extern	const	char	VDECL	szWRRDFAIL [];	// 訡  ᮧ.
extern	const	char	VDECL	szLOOKUP   [];	// 㥬.
extern	const	char	VDECL	szCOPY     [];	// 㥬.
extern	const	char	VDECL	szMOVE     [];	// ६頥.
extern	const	char	VDECL	szCOMP     [];	// ࠢ.
extern	const	char	VDECL	szDEL      [];	// 塞.
extern	const	char	VDECL	szDELFAIL  [];	// 訡  㤠.
extern	const	char	VDECL	szGOTO     [];	// 室  ⠫.
extern	const	char	VDECL	szGOTOFAIL [];	// 訡  室.
extern	const	char	VDECL	szSET      [];	// ⠭ ਡ.
extern	const	char	VDECL	szSETFAIL  [];	// 訡  ⠭.

extern	const	char	VDECL	szEDFULL   [];	//  ९.
extern	const	char	VDECL	szENOENT   [];	//  䠩  ४ਨ.
extern	const	char	VDECL	szEACCES   [];	//  㯠.
extern	const	char	VDECL	szEMFILE   [];	//  墠⠥ FILES.
extern	const	char	VDECL	szENOMEM   [];	//  墠⠥ .
extern	const	char	VDECL	szESIZE	   [];	//  ᫨誮 .
extern	const	char	VDECL	szESYNT    [];	// ⠪᪠ 訡.
extern	const	char	VDECL	szEMATCH   [];	// ᮮ⢥⢨ open/close.
extern	const	char	VDECL	szEINDEX   [];	//  .
extern	const	char	VDECL	szENULL    [];	// 饭  NULL-㪠⥫.

void	STDECL	exfind	(void);			// ஢ 訡 ENOENT
						// ᫥饩 䠩 樨.

int	STDECL	excode_handle	(int code,	// ࠡ⪠ १
			const char* path,	// 䠩 樨.
			const char* pszSuccess,
			const char* pszFailure);

int	STDECL	exopen_handle	(int fd,	// ࠡ⪠ १
			const char *path,	//  䠩.
			int access);

int	STDECL	exread_handle	     (int fd);	// 襭  ⥭.
void	STDECL	exread_fail_handle   (int fd);	// ࠡ⪠ 訡 ⥭.

int	STDECL	exwrite_handle	     (int fd);	// 襭  .
void	STDECL	exwrite_fail_handle  (int fd);	// ࠡ⪠ 訡 .
void	STDECL	exwrite_full_handle  (int fd);	// ࠡ⪠ ९ ᪠.

int	STDECL	exclose_handle	     (int fd);	// 襭  ⨥.
void	STDECL	exclose_fail_handle  (int fd);	// ࠡ⪠ 訡 .

int	STDECL	exio_handle	     (int fd);	// 襭   /.
void	STDECL	exio_fail_handle     (int fd);	// ࠡ⪠ 訡 /.

int	STDECL	exalloc_fail_handle  (void);	// 訡 ࠧ饭.

void	STDECL	exprinterrno	     (void);	// 맮 exprinterror  errno.
const char* STDECL exstrerrno	     (void);	//  ᮮ饭  errno.

//	稥 ६.
extern	int	VDECL	_exfind;		//  exfind()

#ifdef __cplusplus
}
#endif

//	 -㭪権.
#define exfind()		( (void) (_exfind = 1)		)
#define exread_handle(fd)	( exio_handle (fd)		)
#define exwrite_handle(fd)	( exio_handle (fd)		)
#define exclose_handle(fd)	( fd >= 0			)
#define exio_handle(fd)		( !excatch && ((fd) >= 0)	)
#define exread_fail_handle(fd)	( exio_fail_handle (fd)		)
#define exwrite_fail_handle(fd)	( exio_fail_handle (fd)		)
#define exwrite_full_handle(fd)	( exprinterror (szF1, szEDFULL)	)
#define exclose_fail_handle(fd)	( exio_fail_handle (fd)		)
#define exio_fail_handle(fd)	( exprinterrno()               	)

#endif
