/*      exios.h

	⮪ -뢮 c ࠡ⪮ 訡 (C++).

	(C) ..⮢, ..஢,   PAH, 1999 - 2000
	All Rights Reserved.
*/
#ifndef __cplusplus
#error Must use C++ for the exios.h
#endif
#ifndef _EXIOSTR_H
#define _EXIOSTR_H

#include <iostream.h>

#ifndef _EXDEF_H
#include <exdef.h>
#endif

class	exofstream
{
  char	  *psBuf;		//    .
  char ES_*epsBuf0;		// 砫 䠩   0.
  char ES_*epsBuf;		//  .
  int	  fd;			// ਯ 䠩.
  void  EXDECL	check();	// ⮢   ᨬ.
  int	EXDECL	_open     (const void *path);		//   䠩.
  char*	EXDECL	_opentext (void *ps, size_t len);	//   ⥪.
  exofstream & EXDECL _puts  (const void *psz);		//  ப.
  exofstream & EXDECL _seekp (long offset, int from);	// 樮஢.
public:
  exofstream    ()			{ psBuf = NULL;		}
  exofstream    (const char* path)	{ open (path);		}
  ~exofstream   ()			{ if (psBuf) close ();	}

  int	EXDECL	open     (const char* path)	{ return (_open (path));     }
  char*	EXDECL	opentext (char* ps, size_t len)	{ return (_opentext(ps,len));}
  void	EXDECL	openstub () { opentext (NULL, 0); }	// ⨢ .
  void  EXDECL	flush    ();				//  .
  void  EXDECL	close    ();				// 襭 .

  exofstream & EXDECL operator << (const char * psz) { return (_puts (psz)); }
  exofstream & EXDECL operator << (char c)   { check();
					       *psBuf++ = c; return (*this); }
  exofstream & EXDECL operator << (unsigned
				   short  n) { return *this << uitoatmp (n); }
  exofstream & EXDECL operator << (short  n) { return *this << itoatmp  (n); }
  exofstream & EXDECL operator << (unsigned
				   int    n) { return *this << uitoatmp (n); }
  exofstream & EXDECL operator << (int    n) { return *this << itoatmp  (n); }
  exofstream & EXDECL operator << (unsigned
				   long   n) { return *this << ultoatmp (n); }
  exofstream & EXDECL operator << (long	  n) { return *this << ltoatmp  (n); }
//exofstream & EXDECL operator << (float  n);
//exofstream & EXDECL operator << (double n);
//exofstream & EXDECL operator << (void *);
  exofstream & EXDECL operator << (exofstream & (EXDECL *_f)(exofstream & _f))
				{ return (*_f)(*this); }

  exofstream & EXDECL seekp (long offset, ios::seek_dir from = ios::beg)
				{ return _seekp (offset, from); }
  long	       EXDECL tellp ();
};                  

inline exofstream & EXDECL endl (exofstream & s) { return (s << '\n'); }
inline exofstream & EXDECL ends (exofstream & s) { return (s << '\0'); }

#endif//_EXIOSTR_H
