/*	bstring.h

	ப ६ .

	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#ifndef _BSTRING_H
#define _BSTRING_H

#ifndef __EXDEF_H
#include <exdef.h>
#endif

#define	BSTRING(id,max)	size_t id [3 + (max)/sizeof(size_t)] = {(max), 0, 0}
//	  : { max, len, char [max + 1] }
//	max   ⮬ 0;  ᨢ      .
typedef size_t	bstring [];		// 뫪  .

#ifdef __cplusplus
extern "C" {
#endif

//	 㭪樨. (s) -  ࠬ   䥪⮬.
size_t	EXDECL	bsmax	(bstring s);	// ᨬ쭠  ப + 1.
size_t	EXDECL	bslen	(bstring s);	//   ப.
char*	EXDECL	bsval	(bstring s);	// 砫 ப.
char*	EXDECL	bsterm	(bstring s);	// 砫 ᢮ .	(s)
size_t	EXDECL	bsleft	(bstring s);	//  ᢮  + 1.	(s)

//	஢ ( 砫 ப,  ९ ᥪ).
char*	EXDECL	bscpy	(bstring s, const char* src);	    	// .	(s)
char*	EXDECL	bslcpy	(bstring s, size_t l, const char* src); // .	(s)
char*	EXDECL	bscat	(bstring s, const char* src);		// .

//	஢  ࠭祭 ᫠ ᨬ.
char*	EXDECL	bsncpy	(bstring s, const char* src, size_t n);		 //(s)
char*	EXDECL	bslncpy	(bstring s, size_t l, const char* src, size_t n);//(s)
char*	EXDECL	bsncat	(bstring s, const char* src, size_t n);

//      㬥⠫ 㭪樨.
#ifdef __cplusplus
char&	EXDECL	_bsmax	(bstring s);	// 뫪  ᨬ .
char&	EXDECL	_bslen	(bstring s);	// 뫪  ⥪ .
//	㬥⠫ 㭪樨   ᫮ 0-࠭祭: 
//		bslen (s) == strlen (bsval (s))
//	0 - ࠭祭 ⠭ ஢  ᢠ
//		*bsterm (s) = 0
//	᫨ ⮫쪮 0 <= bslen (s) <= strlen (bsval (s))
}
#endif

//	 -㭪権.
#define bsmax(s)	((const size_t) (s) [0])
#define bslen(s)	((const size_t) (s) [1])
#define bsval(s)	((char *)((s) + 2))
#define bsterm(s)	(bsval (s) + bslen (s))
#define bsleft(s)	(bsmax (s) - bslen (s))
#define _bsmax(s)	((s) [0])
#define _bslen(s)	((s) [1])
#define bscpy(s,src)		(_bslen (s) = 0,   bscat (s,src))
#define bslcpy(s,l,src)		(_bslen (s) = (l), bscat (s,src))
#define bsncpy(s,src,n)		(_bslen (s) = 0,   bsncat (s,src,n))
#define bslncpy(s,l,src,n)	(_bslen (s) = (l), bsncat (s,src,n))

#endif
