/*	open.h

	  io.h.
		
	(C) ..஢,   PAH, 1993 - 2000
	All Rights Reserved.
*/
#ifndef _OPEN_H
#define _OPEN_H

#include <io.h>			// 㭪樨 io.h.
#include <fcntl.h>		//   䠩.
#include <sys\stat.h>		//  ᮧ 䠩.

#define	openbr(path)	open(path,O_RDONLY | O_BINARY)

#define	openbrw(path)	open(path,O_RDWR   | O_BINARY)

#define	openb(path)	open(path,O_RDWR   | O_BINARY |	O_CREAT,\
							S_IREAD | S_IWRITE)
#define	openbe(path)	open(path,O_RDWR   | O_BINARY |	O_CREAT | O_EXCL,\
							S_IREAD | S_IWRITE)
#define	openba(path)	open(path,O_RDWR   | O_BINARY |	O_CREAT | O_APPEND,\
							S_IREAD | S_IWRITE)
#define	openbwr(path)	open(path,O_RDWR   | O_BINARY |	O_CREAT | O_TRUNC,\
							S_IREAD | S_IWRITE)
#define	openbw(path)	open(path,O_WRONLY | O_BINARY |	O_CREAT | O_TRUNC,\
							S_IREAD | S_IWRITE)

#define	opentr(path)	open(path,O_RDONLY | O_TEXT)

#define	opentrw(path)	open(path,O_RDWR   | O_TEXT)

#define	opent(path)	open(path,O_RDWR   | O_TEXT |	O_CREAT,\
							S_IREAD | S_IWRITE)
#define	opente(path)	open(path,O_RDWR   | O_TEXT |	O_CREAT | O_EXCL,\
							S_IREAD | S_IWRITE)
#define	openta(path)	open(path,O_RDWR   | O_TEXT |	O_CREAT | O_APPEND,\
							S_IREAD | S_IWRITE)
#define	opentwr(path)	open(path,O_RDWR   | O_TEXT |	O_CREAT | O_TRUNC,\
							S_IREAD | S_IWRITE)
#define	opentw(path)	open(path,O_WRONLY | O_TEXT |	O_CREAT | O_TRUNC,\
							S_IREAD | S_IWRITE)

#if __TURBOC__ >= 0x460
#define _chmod	_rtl_chmod
#define _creat	_rtl_creat
#define _open	_rtl_open
#define _read	_rtl_read
#define _write	_rtl_write
#define _close	_rtl_close
#endif

#endif
